* New EVEN - S*Basic function returns long or int rounded to even number
*
* V0.02i, pjw, 2oi6, new design and no xrefs
* V0.03,  pjw, 2oi8, quicker, shorter; added ODD
* V0.04, pjw, 2019 Jul 21, EVEN returns rounded up value

        section code

        xdef EVEN

        xref getpars,l2frtr

        include dev8_keys_sbasic
        include dev8_keys_err

*
EVEN
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Usage: NB! Word ints treated as ints; everything else as longs
*
*       even_number  = EVEN(lint)
* or
*       even_number% = EVEN(int%)
*
* int%/lint rounde UP to neared even integer of the same type
*

        moveq #$0f,d0
        and.b 1(a6,a3.l),d0     get type

        subq.w #3,d0            int?
        bne.s long               nope, so try long

*
int
        moveq #$10,d0
        bsr getpars             get one int
        bne.s exit

        move.w 0(a6,a1.l),d1
        bmi.s i_min

        addq.w #1,d1
        bpl.s i_done
        bra.s err_ov

i_min
        addq.w #1,d1

i_done
        bclr #0,d1
        move.w d1,(a6,a1.l)

        moveq #3,d4             return integer
        moveq #0,d0
rts
        rts

*
long
        moveq #$16,d0
        bsr getpars             get one long
        bne.s exit

        move.l 0(a6,a1.l),d1
        bmi.s l_min

        addq.l #1,d1
        bpl.s l_done
        bra.s err_ov

l_min
        addq.l #1,d1

l_done
        addq.l #4,sb_arthp(a6)

        bclr #0,d1
        bra l2frtr

*
err_bp
        moveq #err.ipar,d0

*
exit
        rts

*
err_ov
        moveq #err.ovfl,d0
        rts


*
        end
